diff -ruN vdr-1.7.17/PLUGINS/src/dvbhddevice/setup.c vdr-1.7.18/PLUGINS/src/dvbhddevice/setup.c
--- vdr-1.7.17/PLUGINS/src/dvbhddevice/setup.c	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.18/PLUGINS/src/dvbhddevice/setup.c	2011-04-17 13:45:17.000000000 +0200
@@ -0,0 +1,252 @@
+/*
+ * setup.c: Setup for the DVB HD Full Featured On Screen Display
+ *
+ * See the README file for copyright information and how to reach the author.
+ *
+ * $Id: setup.c 1.11 2011/04/17 11:45:17 kls Exp $
+ */
+
+#include "setup.h"
+#include "hdffcmd.h"
+
+const int kResolutions = 4;
+const int kTvFormats = 2;
+const int kVideoConversions = 6;
+const int kAnalogueVideos = 4;
+const int kAudioDownmixes = 5;
+const int kOsdSizes = 5;
+const int kRemoteProtocols = 3;
+
+const int kResolution1080i = 0;
+const int kResolution720p = 1;
+const int kResolution576p = 2;
+const int kResolution576i = 3;
+
+static const char * ResolutionItems[] =
+{
+    "1080i",
+    "720p",
+    "576p",
+    "576i",
+    NULL
+};
+
+static const char * TvFormatItems[] =
+{
+    "4/3",
+    "16/9",
+    NULL
+};
+
+static const char * VideoConversionItems[] =
+{
+    "Automatic",
+    "Letterbox 16/9",
+    "Letterbox 14/9",
+    "Pillarbox",
+    "CentreCutOut",
+    "Always 16/9",
+    NULL
+};
+
+static const char * AnalogueVideoItems[] =
+{
+    "Disabled",
+    "RGB",
+    "CVBS + YUV",
+    "YC (S-Video)",
+    NULL
+};
+
+static const char * AudioDownmixItems[] =
+{
+    "Disabled",
+    "Analogue only",
+    "Always",
+    "Automatic",
+    "HDMI only",
+    NULL
+};
+
+static const char * OsdSizeItems[] =
+{
+    "Follow resolution",
+    "1920x1080",
+    "1280x720",
+    "1024x576",
+    "720x576",
+    NULL
+};
+
+static const char * RemoteProtocolItems[] =
+{
+    "none",
+    "RC5",
+    "RC6",
+    NULL
+};
+
+cHdffSetup gHdffSetup;
+
+cHdffSetup::cHdffSetup(void)
+{
+    Resolution = kResolution1080i;
+    TvFormat = HDFF::tvFormat16by9;
+    VideoConversion = HDFF::videoConversionPillarbox;
+    AnalogueVideo = HDFF::videoOutCvbsYuv;
+    AudioDelay = 0;
+    AudioDownmix = HDFF::downmixAutomatic;
+    OsdSize = 0;
+    CecEnabled = 1;
+    RemoteProtocol = 1;
+    RemoteAddress = -1;
+    HighLevelOsd = 1;
+    TrueColorOsd = 1;
+}
+
+bool cHdffSetup::SetupParse(const char *Name, const char *Value)
+{
+    if      (strcmp(Name, "Resolution")      == 0) Resolution      = atoi(Value);
+    else if (strcmp(Name, "TvFormat")        == 0) TvFormat        = atoi(Value);
+    else if (strcmp(Name, "VideoConversion") == 0) VideoConversion = atoi(Value);
+    else if (strcmp(Name, "AnalogueVideo")   == 0) AnalogueVideo   = atoi(Value);
+    else if (strcmp(Name, "AudioDelay")      == 0) AudioDelay      = atoi(Value);
+    else if (strcmp(Name, "AudioDownmix")    == 0) AudioDownmix    = atoi(Value);
+    else if (strcmp(Name, "OsdSize")         == 0) OsdSize         = atoi(Value);
+    else if (strcmp(Name, "CecEnabled")      == 0) CecEnabled      = atoi(Value);
+    else if (strcmp(Name, "RemoteProtocol")  == 0) RemoteProtocol  = atoi(Value);
+    else if (strcmp(Name, "RemoteAddress")   == 0) RemoteAddress   = atoi(Value);
+    else if (strcmp(Name, "HighLevelOsd")    == 0) HighLevelOsd    = atoi(Value);
+    else if (strcmp(Name, "TrueColorOsd")    == 0) TrueColorOsd    = atoi(Value);
+    else return false;
+    return true;
+}
+
+void cHdffSetup::GetOsdSize(int &Width, int &Height, double &PixelAspect)
+{
+    if (OsdSize == 0) {
+        if (Resolution == kResolution1080i) {
+            Width = 1920;
+            Height = 1080;
+        }
+        else if (Resolution == kResolution720p) {
+            Width = 1280;
+            Height = 720;
+        }
+        else {
+            Width = 720;
+            Height = 576;
+        }
+        if (TvFormat == HDFF::tvFormat16by9)
+            PixelAspect = 16.0 / 9.0;
+        else
+            PixelAspect = 4.0 / 3.0;
+    }
+    else if (OsdSize == 1) {
+        Width = 1920;
+        Height = 1080;
+        PixelAspect = 16.0 / 9.0;
+    }
+    else if (OsdSize == 2) {
+        Width = 1280;
+        Height = 720;
+        PixelAspect = 16.0 / 9.0;
+    }
+    else if (OsdSize == 3) {
+        Width = 1024;
+        Height = 576;
+        PixelAspect = 16.0 / 9.0;
+    }
+    else {
+        Width = 720;
+        Height = 576;
+        PixelAspect = 4.0 / 3.0;
+    }
+  PixelAspect /= double(Width) / Height;
+}
+
+HDFF::eHdmiVideoMode cHdffSetup::GetVideoMode(void)
+{
+    switch (Resolution)
+    {
+        case kResolution1080i:
+        default:
+            return HDFF::videoMode1080i50;
+        case kResolution720p:
+            return HDFF::videoMode720p50;
+        case kResolution576p:
+            return HDFF::videoMode576p50;
+        case kResolution576i:
+            return HDFF::videoMode576i50;
+    }
+}
+
+cHdffSetupPage::cHdffSetupPage(HDFF::cHdffCmdIf * pHdffCmdIf)
+{
+    mHdffCmdIf = pHdffCmdIf;
+    mNewHdffSetup = gHdffSetup;
+
+    Add(new cMenuEditStraItem("Resolution", &mNewHdffSetup.Resolution, kResolutions, ResolutionItems));
+    Add(new cMenuEditStraItem("TV format", &mNewHdffSetup.TvFormat, kTvFormats, TvFormatItems));
+    Add(new cMenuEditStraItem("Video Conversion", &mNewHdffSetup.VideoConversion, kVideoConversions, VideoConversionItems));
+    Add(new cMenuEditStraItem("Analogue Video", &mNewHdffSetup.AnalogueVideo, kAnalogueVideos, AnalogueVideoItems));
+    Add(new cMenuEditIntItem("Audio Delay (ms)", &mNewHdffSetup.AudioDelay, 0, 500));
+    Add(new cMenuEditStraItem("Audio Downmix", &mNewHdffSetup.AudioDownmix, kAudioDownmixes, AudioDownmixItems));
+    Add(new cMenuEditStraItem("Osd Size", &mNewHdffSetup.OsdSize, kOsdSizes, OsdSizeItems));
+    Add(new cMenuEditBoolItem("HDMI CEC", &mNewHdffSetup.CecEnabled));
+    Add(new cMenuEditStraItem("Remote Control Protocol", &mNewHdffSetup.RemoteProtocol, kRemoteProtocols, RemoteProtocolItems));
+    Add(new cMenuEditIntItem("Remote Control Address", &mNewHdffSetup.RemoteAddress, -1, 31));
+    Add(new cMenuEditBoolItem("High Level OSD", &mNewHdffSetup.HighLevelOsd));
+    Add(new cMenuEditBoolItem("Allow True Color OSD", &mNewHdffSetup.TrueColorOsd));
+}
+
+cHdffSetupPage::~cHdffSetupPage(void)
+{
+}
+
+void cHdffSetupPage::Store(void)
+{
+    SetupStore("Resolution", mNewHdffSetup.Resolution);
+    SetupStore("TvFormat", mNewHdffSetup.TvFormat);
+    SetupStore("VideoConversion", mNewHdffSetup.VideoConversion);
+    SetupStore("AnalogueVideo", mNewHdffSetup.AnalogueVideo);
+    SetupStore("AudioDelay", mNewHdffSetup.AudioDelay);
+    SetupStore("AudioDownmix", mNewHdffSetup.AudioDownmix);
+    SetupStore("OsdSize", mNewHdffSetup.OsdSize);
+    SetupStore("CecEnabled", mNewHdffSetup.CecEnabled);
+    SetupStore("RemoteProtocol", mNewHdffSetup.RemoteProtocol);
+    SetupStore("RemoteAddress", mNewHdffSetup.RemoteAddress);
+    SetupStore("HighLevelOsd", mNewHdffSetup.HighLevelOsd);
+    SetupStore("TrueColorOsd", mNewHdffSetup.TrueColorOsd);
+
+    if (mHdffCmdIf)
+    {
+        if (mNewHdffSetup.Resolution != gHdffSetup.Resolution)
+        {
+            mHdffCmdIf->CmdHdmiSetVideoMode(mNewHdffSetup.GetVideoMode());
+        }
+        HDFF::tVideoFormat videoFormat;
+        HDFF::tHdmiConfig hdmiConfig;
+
+        videoFormat.AutomaticEnabled = true;
+        videoFormat.AfdEnabled = true;
+        videoFormat.TvFormat = (HDFF::eTvFormat) mNewHdffSetup.TvFormat;
+        videoFormat.VideoConversion = (HDFF::eVideoConversion) mNewHdffSetup.VideoConversion;
+        mHdffCmdIf->CmdAvSetVideoFormat(0, &videoFormat);
+
+        mHdffCmdIf->CmdAvSetAudioDelay(mNewHdffSetup.AudioDelay);
+        mHdffCmdIf->CmdAvSetAudioDownmix((HDFF::eDownmixMode) mNewHdffSetup.AudioDownmix);
+
+        mHdffCmdIf->CmdMuxSetVideoOut((HDFF::eVideoOut) mNewHdffSetup.AnalogueVideo);
+
+        hdmiConfig.TransmitAudio = true;
+        hdmiConfig.ForceDviMode = false;
+        hdmiConfig.CecEnabled = mNewHdffSetup.CecEnabled;
+        mHdffCmdIf->CmdHdmiConfigure(&hdmiConfig);
+
+        mHdffCmdIf->CmdRemoteSetProtocol((HDFF::eRemoteProtocol) mNewHdffSetup.RemoteProtocol);
+        mHdffCmdIf->CmdRemoteSetAddressFilter(mNewHdffSetup.RemoteAddress >= 0, mNewHdffSetup.RemoteAddress);
+    }
+
+    gHdffSetup = mNewHdffSetup;
+}
diff -ruN vdr-1.7.17/PLUGINS/src/dvbhddevice/setup.h vdr-1.7.18/PLUGINS/src/dvbhddevice/setup.h
--- vdr-1.7.17/PLUGINS/src/dvbhddevice/setup.h	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.18/PLUGINS/src/dvbhddevice/setup.h	2011-04-17 13:20:22.000000000 +0200
@@ -0,0 +1,53 @@
+/*
+ * setup.h: Setup for the DVB HD Full Featured On Screen Display
+ *
+ * See the README file for copyright information and how to reach the author.
+ *
+ * $Id: setup.h 1.8 2011/04/17 11:20:22 kls Exp $
+ */
+
+#ifndef _HDFF_SETUP_H_
+#define _HDFF_SETUP_H_
+
+#include <vdr/plugin.h>
+#include "hdffcmd.h"
+
+struct cHdffSetup
+{
+    cHdffSetup(void);
+    bool SetupParse(const char * Name, const char * Value);
+    void GetOsdSize(int &Width, int &Height, double &PixelAspect);
+    HDFF::eHdmiVideoMode GetVideoMode(void);
+
+    int Resolution;
+    int TvFormat;
+    int VideoConversion;
+    int AnalogueVideo;
+    int AudioDelay;
+    int AudioDownmix;
+    int OsdSize;
+    int CecEnabled;
+    int RemoteProtocol;
+    int RemoteAddress;
+
+    int HighLevelOsd;
+    int TrueColorOsd;
+};
+
+extern cHdffSetup gHdffSetup;
+
+class cHdffSetupPage : public cMenuSetupPage
+{
+private:
+    HDFF::cHdffCmdIf * mHdffCmdIf;
+    cHdffSetup mNewHdffSetup;
+
+protected:
+    virtual void Store(void);
+
+public:
+    cHdffSetupPage(HDFF::cHdffCmdIf * pHdffCmdIf);
+    virtual ~cHdffSetupPage(void);
+};
+
+#endif
diff -ruN vdr-1.7.17/PLUGINS/src/dvbsddevice/HISTORY vdr-1.7.18/PLUGINS/src/dvbsddevice/HISTORY
--- vdr-1.7.17/PLUGINS/src/dvbsddevice/HISTORY	2010-01-30 12:03:08.000000000 +0100
+++ vdr-1.7.18/PLUGINS/src/dvbsddevice/HISTORY	2011-04-17 14:57:29.000000000 +0200
@@ -15,3 +15,7 @@
 
 - The PCR pid is now recorded for channels where this is different from the
   video PID.
+
+2011-04-17: Version 0.0.4
+
+- Removed an obsolete local variable in dvbsdffosd.c (thanks to Paul Menzel).
diff -ruN vdr-1.7.17/PLUGINS/src/dvbsddevice/dvbsddevice.c vdr-1.7.18/PLUGINS/src/dvbsddevice/dvbsddevice.c
--- vdr-1.7.17/PLUGINS/src/dvbsddevice/dvbsddevice.c	2010-01-30 11:05:42.000000000 +0100
+++ vdr-1.7.18/PLUGINS/src/dvbsddevice/dvbsddevice.c	2011-04-17 14:55:43.000000000 +0200
@@ -3,13 +3,13 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbsddevice.c 1.3 2010/01/30 10:05:42 kls Exp $
+ * $Id: dvbsddevice.c 1.4 2011/04/17 12:55:43 kls Exp $
  */
 
 #include <vdr/plugin.h>
 #include "dvbsdffdevice.h"
 
-static const char *VERSION        = "0.0.3";
+static const char *VERSION        = "0.0.4";
 static const char *DESCRIPTION    = "SD Full Featured DVB device";
 
 class cPluginDvbsddevice : public cPlugin {
diff -ruN vdr-1.7.17/PLUGINS/src/dvbsddevice/dvbsdffosd.c vdr-1.7.18/PLUGINS/src/dvbsddevice/dvbsdffosd.c
--- vdr-1.7.17/PLUGINS/src/dvbsddevice/dvbsdffosd.c	2010-09-19 14:43:45.000000000 +0200
+++ vdr-1.7.18/PLUGINS/src/dvbsddevice/dvbsdffosd.c	2011-04-17 14:55:09.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbsdffosd.c 2.2 2010/09/19 12:43:45 kls Exp $
+ * $Id: dvbsdffosd.c 2.3 2011/04/17 12:55:09 kls Exp $
  */
 
 #include "dvbsdffosd.h"
@@ -73,8 +73,7 @@
            Flush();
         }
      else if (shown) {
-        cBitmap *Bitmap;
-        for (int i = 0; (Bitmap = GetBitmap(i)) != NULL; i++) {
+        for (int i = 0; GetBitmap(i); i++) {
             Cmd(OSD_SetWindow, 0, i + 1);
             Cmd(OSD_Close);
             }
@@ -108,8 +107,7 @@
 eOsdError cDvbSdFfOsd::SetAreas(const tArea *Areas, int NumAreas)
 {
   if (shown) {
-     cBitmap *Bitmap;
-     for (int i = 0; (Bitmap = GetBitmap(i)) != NULL; i++) {
+     for (int i = 0; GetBitmap(i); i++) {
          Cmd(OSD_SetWindow, 0, i + 1);
          Cmd(OSD_Close);
          }
diff -ruN vdr-1.7.17/PLUGINS/src/osddemo/HISTORY vdr-1.7.18/PLUGINS/src/osddemo/HISTORY
--- vdr-1.7.17/PLUGINS/src/osddemo/HISTORY	2011-02-20 16:06:52.000000000 +0100
+++ vdr-1.7.18/PLUGINS/src/osddemo/HISTORY	2011-04-17 15:05:01.000000000 +0200
@@ -25,3 +25,12 @@
 2011-02-20: Version 0.2.0
 
 - Added support for TrueColor OSD.
+
+2011-03-28: Version 0.2.1
+
+- Added Cancel(3) to ~cTrueColorDemo() (thanks to Reinhard Nissl).
+- Added a missing font deletion in cTrueColorDemo::Action() (thanks to Reinhard Nissl).
+
+2011-04-17: Version 0.2.2
+
+- Fixed a possible NULL pointer dereference in osddemo.c (reported by Paul Menzel).
diff -ruN vdr-1.7.17/PLUGINS/src/osddemo/osddemo.c vdr-1.7.18/PLUGINS/src/osddemo/osddemo.c
--- vdr-1.7.17/PLUGINS/src/osddemo/osddemo.c	2011-02-26 13:08:13.000000000 +0100
+++ vdr-1.7.18/PLUGINS/src/osddemo/osddemo.c	2011-04-17 15:05:13.000000000 +0200
@@ -3,13 +3,13 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: osddemo.c 2.3 2011/02/26 12:08:13 kls Exp $
+ * $Id: osddemo.c 2.5 2011/04/17 13:05:13 kls Exp $
  */
 
 #include <vdr/osd.h>
 #include <vdr/plugin.h>
 
-static const char *VERSION        = "0.2.0";
+static const char *VERSION        = "0.2.2";
 static const char *DESCRIPTION    = "Demo of arbitrary OSD setup";
 static const char *MAINMENUENTRY  = "Osd Demo";
 
@@ -103,6 +103,7 @@
 
 cTrueColorDemo::~cTrueColorDemo()
 {
+  Cancel(3);
   delete osd;
 }
 
@@ -262,12 +263,13 @@
              case 3: {
                        if (cFont *Font = cFont::CreateFont(DefaultFontOsd, osd->Height() / 10)) {
                           NextPixmap = CreateTextPixmap("Millions of colors", Line, 1, clrYellow, clrTransparent, Font);
+                          delete Font;
                           if (NextPixmap) {
                              FadeInPixmap = NextPixmap;
+                             Start = cTimeMs::Now();
+                             StartLine = Line;
+                             Line += NextPixmap->DrawPort().Height();
                              }
-                          Start = cTimeMs::Now();
-                          StartLine = Line;
-                          Line += NextPixmap->DrawPort().Height();
                           }
                        State++;
                      }
diff -ruN vdr-1.7.17/config.h vdr-1.7.18/config.h
--- vdr-1.7.17/config.h	2010-10-24 13:22:35.000000000 +0200
+++ vdr-1.7.18/config.h	2011-03-13 13:02:31.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 2.29 2010/10/24 11:22:35 kls Exp $
+ * $Id: config.h 2.30 2011/03/13 12:02:31 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.7.17"
-#define VDRVERSNUM   10717  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.18"
+#define VDRVERSNUM   10718  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.7.17"
-#define APIVERSNUM   10717  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.7.18"
+#define APIVERSNUM   10718  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
diff -ruN vdr-1.7.17/device.h vdr-1.7.18/device.h
--- vdr-1.7.17/device.h	2010-10-24 14:11:16.000000000 +0200
+++ vdr-1.7.18/device.h	2011-03-21 18:58:41.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 2.23 2010/10/24 12:11:16 kls Exp $
+ * $Id: device.h 2.24 2011/03/21 17:58:41 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -405,10 +405,9 @@
          ///< (default is PAL).
   virtual void GetVideoSize(int &Width, int &Height, double &VideoAspect);
          ///< Returns the With, Height and VideoAspect ratio of the currently
-         ///< displayed video material. The data returned by this function is
-         ///< only used for informational purposes (if any). Width and
-         ///< Height are given in pixel (e.g. 720x576) and VideoAspect is
-         ///< e.g. 1.33333 for a 4:3 broadcast, or 1.77778 for 16:9.
+         ///< displayed video material. Width and Height are given in pixel
+         ///< (e.g. 720x576) and VideoAspect is e.g. 1.33333 for a 4:3 broadcast,
+         ///< or 1.77778 for 16:9.
          ///< The default implementation returns 0 for Width and Height
          ///< and 1.0 for VideoAspect.
   virtual void GetOsdSize(int &Width, int &Height, double &PixelAspect);
diff -ruN vdr-1.7.17/dvbspu.h vdr-1.7.18/dvbspu.h
--- vdr-1.7.17/dvbspu.h	2009-12-13 13:07:00.000000000 +0100
+++ vdr-1.7.18/dvbspu.h	2011-03-27 16:50:48.000000000 +0200
@@ -8,7 +8,7 @@
  *
  * parts of this file are derived from the OMS program.
  *
- * $Id: dvbspu.h 2.4 2009/12/13 12:07:00 kls Exp $
+ * $Id: dvbspu.h 2.5 2011/03/27 14:50:48 kls Exp $
  */
 
 #ifndef __DVBSPU_H
@@ -32,6 +32,9 @@
     int x1, y1;
     int x2, y2;
 
+    sDvbSpuRect(void) {
+        x1 = y1 = x2 = y2 = 0;
+    };
     int width() const {
         return x2 - x1 + 1;
     };
diff -ruN vdr-1.7.17/dvbsubtitle.c vdr-1.7.18/dvbsubtitle.c
--- vdr-1.7.17/dvbsubtitle.c	2011-03-12 16:13:03.000000000 +0100
+++ vdr-1.7.18/dvbsubtitle.c	2011-04-17 16:34:05.000000000 +0200
@@ -7,10 +7,13 @@
  * Original author: Marco Schlüßler <marco@lordzodiac.de>
  * With some input from the "subtitle plugin" by Pekka Virtanen <pekka.virtanen@sci.fi>
  *
- * $Id: dvbsubtitle.c 2.11 2011/03/12 15:13:03 kls Exp $
+ * $Id: dvbsubtitle.c 2.17 2011/04/17 14:34:05 kls Exp $
  */
 
+
 #include "dvbsubtitle.h"
+#define __STDC_FORMAT_MACROS // Required for format specifiers
+#include <inttypes.h>
 #include "device.h"
 
 #define PAGE_COMPOSITION_SEGMENT   0x10
@@ -420,7 +423,7 @@
   int PageId(void) { return pageId; }
   int Version(void) { return version; }
   int State(void) { return state; }
-  tArea *GetAreas(double Factor);
+  tArea *GetAreas(double FactorX, double FactorY);
   cSubtitleClut *GetClutById(int ClutId, bool New = false);
   cSubtitleObject *GetObjectById(int ObjectId);
   cSubtitleRegion *GetRegionById(int RegionId, bool New = false);
@@ -446,16 +449,16 @@
 {
 }
 
-tArea *cDvbSubtitlePage::GetAreas(double Factor)
+tArea *cDvbSubtitlePage::GetAreas(double FactorX, double FactorY)
 {
   if (regions.Count() > 0) {
      tArea *Areas = new tArea[regions.Count()];
      tArea *a = Areas;
      for (cSubtitleRegion *sr = regions.First(); sr; sr = regions.Next(sr)) {
-         a->x1 = int(round(Factor * sr->HorizontalAddress()));
-         a->y1 = int(round(Factor * sr->VerticalAddress()));
-         a->x2 = int(round(Factor * (sr->HorizontalAddress() + sr->Width() - 1)));
-         a->y2 = int(round(Factor * (sr->VerticalAddress() + sr->Height() - 1)));
+         a->x1 = int(round(FactorX * sr->HorizontalAddress()));
+         a->y1 = int(round(FactorY * sr->VerticalAddress()));
+         a->x2 = int(round(FactorX * (sr->HorizontalAddress() + sr->Width() - 1)));
+         a->y2 = int(round(FactorY * (sr->VerticalAddress() + sr->Height() - 1)));
          a->bpp = sr->Bpp();
          while ((a->Width() & 3) != 0)
                a->x2++; // aligns width to a multiple of 4, so 2, 4 and 8 bpp will work
@@ -616,10 +619,11 @@
   int timeout;
   tArea *areas;
   int numAreas;
-  double osdFactor;
+  double osdFactorX;
+  double osdFactorY;
   cVector<cBitmap *> bitmaps;
 public:
-  cDvbSubtitleBitmaps(int64_t Pts, int Timeout, tArea *Areas, int NumAreas, double OsdFactor);
+  cDvbSubtitleBitmaps(int64_t Pts, int Timeout, tArea *Areas, int NumAreas, double OsdFactorX, double OsdFactorY);
   ~cDvbSubtitleBitmaps();
   int64_t Pts(void) { return pts; }
   int Timeout(void) { return timeout; }
@@ -627,13 +631,14 @@
   void Draw(cOsd *Osd);
   };
 
-cDvbSubtitleBitmaps::cDvbSubtitleBitmaps(int64_t Pts, int Timeout, tArea *Areas, int NumAreas, double OsdFactor)
+cDvbSubtitleBitmaps::cDvbSubtitleBitmaps(int64_t Pts, int Timeout, tArea *Areas, int NumAreas, double OsdFactorX, double OsdFactorY)
 {
   pts = Pts;
   timeout = Timeout;
   areas = Areas;
   numAreas = NumAreas;
-  osdFactor = OsdFactor;
+  osdFactorX = OsdFactorX;
+  osdFactorY = OsdFactorY;
 }
 
 cDvbSubtitleBitmaps::~cDvbSubtitleBitmaps()
@@ -650,12 +655,27 @@
 
 void cDvbSubtitleBitmaps::Draw(cOsd *Osd)
 {
+  bool Scale = !(DoubleEqual(osdFactorX, 1.0) && DoubleEqual(osdFactorY, 1.0));
+  bool AntiAlias = true;
+  if (Scale && osdFactorX > 1.0 || osdFactorY > 1.0) {
+     // Upscaling requires 8bpp:
+     int Bpp[MAXOSDAREAS];
+     for (int i = 0; i < numAreas; i++) {
+         Bpp[i] = areas[i].bpp;
+         areas[i].bpp = 8;
+         }
+     if (Osd->CanHandleAreas(areas, numAreas) != oeOk) {
+        for (int i = 0; i < numAreas; i++)
+            Bpp[i] = areas[i].bpp = Bpp[i];
+        AntiAlias = false;
+        }
+     }
   if (Osd->SetAreas(areas, numAreas) == oeOk) {
      for (int i = 0; i < bitmaps.Size(); i++) {
          cBitmap *b = bitmaps[i];
-         if (osdFactor != 1.0)
-            b = b->Scale(osdFactor, osdFactor);
-         Osd->DrawBitmap(int(round(b->X0() * osdFactor)), int(round(b->Y0() * osdFactor)), *b);
+         if (Scale)
+            b = b->Scaled(osdFactorX, osdFactorY, AntiAlias);
+         Osd->DrawBitmap(int(round(b->X0() * osdFactorX)), int(round(b->Y0() * osdFactorY)), *b);
          if (b != bitmaps[i])
             delete b;
          }
@@ -733,7 +753,7 @@
      if (Length > PayloadOffset + SubstreamHeaderLength) {
         int64_t pts = PesHasPts(Data) ? PesGetPts(Data) : 0;
         if (pts)
-           dbgconverter("Converter PTS: %lld\n", pts);
+           dbgconverter("Converter PTS: %"PRId64"\n", pts);
         const uchar *data = Data + PayloadOffset + SubstreamHeaderLength; // skip substream header
         int length = Length - PayloadOffset - SubstreamHeaderLength; // skip substream header
         if (ResetSubtitleAssembler)
@@ -769,7 +789,7 @@
      if (Length > PayloadOffset) {
         int64_t pts = PesGetPts(Data);
         if (pts)
-           dbgconverter("Converter PTS: %lld\n", pts);
+           dbgconverter("Converter PTS: %"PRId64"\n", pts);
         const uchar *data = Data + PayloadOffset;
         int length = Length - PayloadOffset;
         if (length > 3) {
@@ -828,7 +848,7 @@
                     if (AssertOsd()) {
                        sb->Draw(osd);
                        Timeout.Set(sb->Timeout() * 1000);
-                       dbgconverter("PTS: %lld  STC: %lld (%lld) timeout: %d\n", sb->Pts(), cDevice::PrimaryDevice()->GetSTC(), Delta, sb->Timeout());
+                       dbgconverter("PTS: %"PRId64"  STC: %"PRId64" (%"PRId64") timeout: %d\n", sb->Pts(), cDevice::PrimaryDevice()->GetSTC(), Delta, sb->Timeout());
                        }
                     bitmaps->Del(sb);
                     }
@@ -862,27 +882,27 @@
 
 void cDvbSubtitleConverter::SetOsdData(void)
 {
-  int OsdWidth;
-  int OsdHeight;
+  int OsdWidth, OsdHeight;
   double OsdAspect;
+  int VideoWidth, VideoHeight;
+  double VideoAspect;
   cDevice::PrimaryDevice()->GetOsdSize(OsdWidth, OsdHeight, OsdAspect);
-  osdDeltaX = osdDeltaY = 0;
-  osdFactor = 1.0;
-  double fw = double(OsdWidth) / displayWidth;
-  double fh = double(OsdHeight) / displayHeight;
-  if (fw >= fh) {
-     osdFactor = fh;
-     osdDeltaX = (OsdWidth - displayWidth * osdFactor) / 2;
+  cDevice::PrimaryDevice()->GetVideoSize(VideoWidth, VideoHeight, VideoAspect);
+  if (OsdWidth == displayWidth && OsdHeight == displayHeight) {
+     osdFactorX = osdFactorY = 1.0;
+     osdDeltaX = osdDeltaY = 0;
      }
   else {
-     osdFactor = fw;
-     osdDeltaY = (OsdHeight - displayHeight * osdFactor) / 2;
+     osdFactorX = VideoAspect * OsdHeight / displayWidth;
+     osdFactorY = double(OsdHeight) / displayHeight;
+     osdDeltaX = (OsdWidth - displayWidth * osdFactorX) / 2;
+     osdDeltaY = (OsdHeight - displayHeight * osdFactorY) / 2;
      }
 }
 
 bool cDvbSubtitleConverter::AssertOsd(void)
 {
-  return osd || (osd = cOsdProvider::NewOsd(int(round(osdFactor * windowHorizontalOffset + osdDeltaX)), int(round(osdFactor * windowVerticalOffset + osdDeltaY)) + Setup.SubtitleOffset, OSD_LEVEL_SUBTITLES));
+  return osd || (osd = cOsdProvider::NewOsd(int(round(osdFactorX * windowHorizontalOffset + osdDeltaX)), int(round(osdFactorY * windowVerticalOffset + osdDeltaY)) + Setup.SubtitleOffset, OSD_LEVEL_SUBTITLES));
 }
 
 int cDvbSubtitleConverter::ExtractSegment(const uchar *Data, int Length, int64_t Pts)
@@ -918,7 +938,7 @@
             page->SetTimeout(Data[6]);
             page->SetState((Data[6 + 1] & 0x0C) >> 2);
             page->regions.Clear();
-            dbgpages("Update page id %d version %d pts %lld timeout %d state %d\n", pageId, page->Version(), page->Pts(), page->Timeout(), page->State());
+            dbgpages("Update page id %d version %d pts %"PRId64" timeout %d state %d\n", pageId, page->Version(), page->Pts(), page->Timeout(), page->State());
             for (int i = 6 + 2; i < segmentLength; i += 6) {
                 cSubtitleRegion *region = page->GetRegionById(Data[i], true);
                 region->SetHorizontalAddress((Data[i + 2] << 8) + Data[i + 3]);
@@ -1079,7 +1099,7 @@
 {
   if (!AssertOsd())
      return;
-  tArea *Areas = Page->GetAreas(osdFactor);
+  tArea *Areas = Page->GetAreas(osdFactorX, osdFactorY);
   int NumAreas = Page->regions.Count();
   int Bpp = 8;
   bool Reduced = false;
@@ -1116,7 +1136,7 @@
             }
          }
      }
-  cDvbSubtitleBitmaps *Bitmaps = new cDvbSubtitleBitmaps(Page->Pts(), Page->Timeout(), Areas, NumAreas, osdFactor);
+  cDvbSubtitleBitmaps *Bitmaps = new cDvbSubtitleBitmaps(Page->Pts(), Page->Timeout(), Areas, NumAreas, osdFactorX, osdFactorY);
   bitmaps->Add(Bitmaps);
   for (cSubtitleRegion *sr = Page->regions.First(); sr; sr = Page->regions.Next(sr)) {
       int posX = sr->HorizontalAddress();
diff -ruN vdr-1.7.17/dvbsubtitle.h vdr-1.7.18/dvbsubtitle.h
--- vdr-1.7.17/dvbsubtitle.h	2011-03-12 15:03:42.000000000 +0100
+++ vdr-1.7.18/dvbsubtitle.h	2011-03-20 14:34:23.000000000 +0100
@@ -6,7 +6,7 @@
  *
  * Original author: Marco Schlüßler <marco@lordzodiac.de>
  *
- * $Id: dvbsubtitle.h 2.5 2011/03/12 14:03:42 kls Exp $
+ * $Id: dvbsubtitle.h 2.6 2011/03/20 13:34:23 kls Exp $
  */
 
 #ifndef __DVBSUBTITLE_H
@@ -35,7 +35,8 @@
   int windowHeight;
   int osdDeltaX;
   int osdDeltaY;
-  double osdFactor;
+  double osdFactorX;
+  double osdFactorY;
   cList<cDvbSubtitlePage> *pages;
   cList<cDvbSubtitleBitmaps> *bitmaps;
   tColor yuv2rgb(int Y, int Cb, int Cr);
diff -ruN vdr-1.7.17/font.c vdr-1.7.18/font.c
--- vdr-1.7.17/font.c	2011-02-26 13:09:18.000000000 +0100
+++ vdr-1.7.18/font.c	2011-03-28 18:29:51.000000000 +0200
@@ -6,7 +6,7 @@
  *
  * BiDi support by Osama Alrawab <alrawab@hotmail.com> @2008 Tripoli-Libya.
  *
- * $Id: font.c 2.7 2011/02/26 12:09:18 kls Exp $
+ * $Id: font.c 2.8 2011/03/28 16:29:51 kls Exp $
  */
 
 #include "font.h"
@@ -520,7 +520,7 @@
   bool ok = fribidi_log2vis(Logical, RtlLen, &Base, Visual, NULL, NULL, NULL);
   if (ok) {
      fribidi_remove_bidi_marks(Visual, RtlLen, NULL, NULL, NULL);
-     Rtl = MALLOC(char, RtlLen * 4);
+     Rtl = MALLOC(char, RtlLen * 4 + 1);
      fribidi_unicode_to_charset(fribidiCharset, Visual, RtlLen, Rtl);
      }
   free(Logical);
diff -ruN vdr-1.7.17/osd.c vdr-1.7.18/osd.c
--- vdr-1.7.17/osd.c	2011-03-12 16:32:33.000000000 +0100
+++ vdr-1.7.18/osd.c	2011-04-17 16:25:07.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.c 2.17 2011/03/12 15:32:33 kls Exp $
+ * $Id: osd.c 2.21 2011/04/17 14:25:07 kls Exp $
  */
 
 #include "osd.h"
@@ -503,8 +503,7 @@
 {
   x -= x0;
   y -= y0;
-  if (0 <= x && x < width && 0 <= y && y < height)
-     SetIndex(x, y, Index(Color));
+  SetIndex(x, y, Index(Color));
 }
 
 void cBitmap::DrawBitmap(int x, int y, const cBitmap &Bitmap, tColor ColorFg, tColor ColorBg, bool ReplacePalette, bool Overlay)
@@ -807,7 +806,7 @@
      }
 }
 
-cBitmap *cBitmap::Scale(double FactorX, double FactorY)
+cBitmap *cBitmap::Scaled(double FactorX, double FactorY, bool AntiAlias)
 {
   // Fixed point scaling code based on www.inversereality.org/files/bitmapscaling.pdf
   // by deltener@mindtremors.com
@@ -815,19 +814,42 @@
   b->Replace(*this); // copy palette
   int RatioX = (Width() << 16) / b->Width();
   int RatioY = (Height() << 16) / b->Height();
-  tIndex *DestRow = b->bitmap;
-  int SourceY = 0;
-  for (int y = 0; y < b->Height(); y++) {
-      int SourceX = 0;
-      tIndex *SourceRow = bitmap + (SourceY >> 16) * Width();
-      tIndex *Dest = DestRow;
-      for (int x = 0; x < b->Width(); x++) {
-          *Dest++ = SourceRow[SourceX >> 16];
-          SourceX += RatioX;
-          }
-      SourceY += RatioY;
-      DestRow += b->Width();
-      }
+  if (!AntiAlias || FactorX <= 1.0 && FactorY <= 1.0) {
+     // Downscaling - no anti-aliasing:
+     tIndex *DestRow = b->bitmap;
+     int SourceY = 0;
+     for (int y = 0; y < b->Height(); y++) {
+         int SourceX = 0;
+         tIndex *SourceRow = bitmap + (SourceY >> 16) * Width();
+         tIndex *Dest = DestRow;
+         for (int x = 0; x < b->Width(); x++) {
+             *Dest++ = SourceRow[SourceX >> 16];
+             SourceX += RatioX;
+             }
+         SourceY += RatioY;
+         DestRow += b->Width();
+         }
+     }
+  else {
+     // Upscaling - anti-aliasing:
+     b->SetBpp(8);
+     int SourceY = 0;
+     for (int y = 0; y < b->Height() - 1; y++) {
+         int SourceX = 0;
+         int sy = SourceY >> 16;
+         uint8_t BlendY = 0xFF - ((SourceY >> 8) & 0xFF);
+         for (int x = 0; x < b->Width() - 1; x++) {
+             int sx = SourceX >> 16;
+             uint8_t BlendX = 0xFF - ((SourceX >> 8) & 0xFF);
+             tColor c1 = b->Blend(GetColor(sx, sy),     GetColor(sx + 1, sy),     BlendX);
+             tColor c2 = b->Blend(GetColor(sx, sy + 1), GetColor(sx + 1, sy + 1), BlendX);
+             tColor c3 = b->Blend(c1, c2, BlendY);
+             b->DrawPixel(x + X0(), y + Y0(), c3);
+             SourceX += RatioX;
+             }
+         SourceY += RatioY;
+         }
+     }
   return b;
 }
 
@@ -1394,6 +1416,7 @@
           case -2: DrawRectangle(cRect(x1,     cy - y, cx - x - x1 + 1, 1), Color); break;
           case -3: DrawRectangle(cRect(x1,     cy + y, cx - x - x1 + 1, 1), Color); break;
           case -4: DrawRectangle(cRect(cx + x, cy + y, x2 - x + 1,      1), Color); break;
+          default: ;
           }
         x++;
         StoppingX += TwoBSquare;
